
--
--		
--
--		$project:	Afterlife Crowd Control | TBC Classic
--		$version:	r21.20502
--		$date:		25/10/2021 R21
--
--		$author:	Michael Boyle (a.k.a. Codermik)
--		$contact:	michael.boyle@softrix.co.uk
--		
--		$twitch:	www.twitch.tv/codermik
--
--
--
--		
--				


local AfterlifePlayerIcon = "Interface\\Addons\\Afterlife\\graphics\\neplayer.tga"
--
--	Close Options Screen
--
function AfterlifeCloseOptions_OnClick()
	hideDemo3DFrame()
	options:Hide()
end

--
--	Simple little function to update settings ui with current saved settings.
--
function AfterlifeUpdateSettings()
	-- checkboxes
	if AfterlifeSettings[1] then AfterlifeEnableAddon:SetChecked(true) end						-- addon status
	if AfterlifeSettings[3] then ChatAnnounceCrowdControls:SetChecked(true) end					-- announce cc in chat
	if AfterlifeSettings[4] then AudioAnnounceCrowdControls:SetChecked(true) end				-- announce cc with audio
	if AfterlifeSettings[5] then ChatAnnounce15sLeft:SetChecked(true) end						-- announce 15s in chat
	if AfterlifeSettings[6] then AudioAnnounce15sLeft:SetChecked(true) end						-- announce 15s with audio
	if AfterlifeSettings[7] then ChatAnnounceCrowdBreaks:SetChecked(true) end					-- announce breaks in chat
	if AfterlifeSettings[8] then AudioAnnounceCrowdBreaks:SetChecked(true) end					-- announce breaks with audio
	if AfterlifeSettings[9] then ChatAnnounceSpellMisses:SetChecked(true) end					-- announce misses in chat
	if AfterlifeSettings[10] then AudioAnnounceSpellMisses:SetChecked(true) end					-- announce misses with audio
	if AfterlifeSettings[11] then ChatAnnounceSpellFailure:SetChecked(true) end					-- announce failures in chat
	if AfterlifeSettings[12] then AudioAnnounceSpellFailure:SetChecked(true) end				-- announce failures with audio
	if AfterlifeSettings[13] then ChatAnnounceInterrupts:SetChecked(true) end					-- announce interrupts in chat
	if AfterlifeSettings[14] then AudioAnnounceInterrupts:SetChecked(true) end					-- announce interrupts with audio
	if AfterlifeSettings[15] then IgnorePersonalBreaks:SetChecked(true) end						-- ignore my own cc breaks?
	if AfterlifeSettings[16] then Display3DTargetFrame:SetChecked(true) end						-- show 3d frame
	if AfterlifeSettings[21] then DisplayBatmanPopup:SetChecked(true) end						-- show Aieee frame
	if AfterlifeSettings[42] then AnnounceInBG:SetChecked(true) end								-- announce in battlegrounds?

	-- bars
	BarSliderHeight:SetValue(AfterlifeSettings[25])
	BarSliderWidth:SetValue(AfterlifeSettings[26])
	BarSliderFont:SetValue(AfterlifeSettings[30])
	BarSliderTexture:SetValue(AfterlifeSettings[27])
	AfterlifeGroupTexture:SetTexture(AfterlifeTextures[AfterlifeSettings[27]])
	update3DPosition()

	-- 3d target
	Controlled3DTargetLeft:SetValue(AfterlifeSettings[19])
	Controlled3DTargetTop:SetValue(AfterlifeSettings[20])
	Controlled3DTargetWidth:SetValue(AfterlifeSettings[17])
	Controlled3DTargetHeight:SetValue(AfterlifeSettings[18])

end

-- toggle 3d target frame, allows you to adjust its position easier
function Toggle3DTarget_OnClick()
	showDemo3DFrame()
end

--
--	Enable / Disable Addon
--
function AfterlifeEnableAddon_OnClick()
	if AfterlifeEnableAddon:GetChecked() then AfterlifeSettings[1] = true else AfterlifeSettings[1] = false end
	if AfterlifeSettings[1] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 is turned ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 is turned OFF!") 
	end
end

--
--	Bar Anchor Toggle
--
function ToggleBarTitle_OnClick()
	if AfterlifeSettings[2] then 
		AfterlifeSettings[2] = false 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Bar group anchors are now hidden.") 
	else 
		AfterlifeSettings[2] = true 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Bar group anchors are now visible - hold ALT and drag the title bars to a preferred location.") 
	end	
	AfterlifePrimaryGroup:SetAnchorVisible(AfterlifeSettings[2])
	if AfterlifeSettings[44] then AfterlifeDiminishGroup:SetAnchorVisible(AfterlifeSettings[2]) end
end

--
--	Toggle Test Bars
--
function TestBarsButton_OnClick()
	AfterlifePrimaryGroup:RegisterBar("TestBar1", "Test Timer 1", 50, 50, AfterlifePlayerIcon, "Interface\\TargetingFrame\\UI-RaidTargetingIcon_1.blp")	
	AfterlifePrimaryGroup:RegisterBar("TestBar2", "Test Timer 2", 40, 40, AfterlifePlayerIcon, "Interface\\TargetingFrame\\UI-RaidTargetingIcon_6.blp")	
	AfterlifePrimaryGroup:RegisterBar("TestBar3", "Test Timer 3", 25, 25, AfterlifePlayerIcon, "Interface\\TargetingFrame\\UI-RaidTargetingIcon_3.blp")	
	AfterlifePrimaryGroup:RegisterBar("TestBar4", "Test Timer 4", 15, 15, AfterlifePlayerIcon, "Interface\\TargetingFrame\\UI-RaidTargetingIcon_2.blp")	
	if AfterlifeSettings[44] then AfterlifeDiminishGroup:RegisterBar("TestDRBar1", "Test DR Timer (Castanova)", 18, 18, AfterlifePlayerIcon, AfterlifeDiminishGfx[2]) end
end

--
--	Chat / Audio Announce Crowd Controls
--
function ChatAnnounceCrowdControls_OnClick()
	if ChatAnnounceCrowdControls:GetChecked() then AfterlifeSettings[3] = true else AfterlifeSettings[3] = false end
	if AfterlifeSettings[3] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce for your crowd controls is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce for your crowd controls is now switched OFF!") 
	end	
end

function AudioAnnounceCrowdControls_OnClick()
	if AudioAnnounceCrowdControls:GetChecked() then AfterlifeSettings[4] = true else AfterlifeSettings[4] = false end
	if AfterlifeSettings[4] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when you control a target is switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when you control a target is switched OFF!") 
	end
end

--
--	Chat/Audio Announce last 15 seconds
--
function ChatAnnounce15sLeft_OnClick()
	if ChatAnnounce15sLeft:GetChecked() then AfterlifeSettings[5] = true else AfterlifeSettings[5] = false end
	if AfterlifeSettings[5] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce your last 15 seconds on controlled targets is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce your last 15 seconds on controlled targets is now switched OFF!") 
	end	
end

function AudioAnnounce15sLeft_OnClick()
	if AudioAnnounce15sLeft:GetChecked() then AfterlifeSettings[6] = true else AfterlifeSettings[6] = false end
	if AfterlifeSettings[6] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound on your last 15 seconds of a controlled target is switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound on your last 15 seconds of a controlled target is switched OFF!") 
	end
end

--
--	Chat/Audio Announce Controlled Breaks.
--
function ChatAnnounceCrowdBreaks_OnClick()
	if ChatAnnounceCrowdBreaks:GetChecked() then AfterlifeSettings[7] = true else AfterlifeSettings[7] = false end
	if AfterlifeSettings[7] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce when your controlled target is broken is turned ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce when your controlled target is broken is turned OFF!") 
	end	
end

function AudioAnnounceCrowdBreaks_OnClick()
	if AudioAnnounceCrowdBreaks:GetChecked() then AfterlifeSettings[8] = true else AfterlifeSettings[8] = false end
	if AfterlifeSettings[8] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when your controlled target gets broken is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when your controlled target gets broken is now switched OFF!") 
	end
end

--
--	Chat/Audio Announce Misses
--
function ChatAnnounceSpellMisses_OnClick()
	if ChatAnnounceSpellMisses:GetChecked() then AfterlifeSettings[9] = true else AfterlifeSettings[9] = false end
	if AfterlifeSettings[9] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce when a spell you cast misses is turned ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce when a spell you cast misses is turned OFF!") 
	end	
end

function AudioAnnounceSpellMisses_OnClick()
	if AudioAnnounceSpellMisses:GetChecked() then AfterlifeSettings[10] = true else AfterlifeSettings[10] = false end
	if AfterlifeSettings[10] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when a spell you cast misses is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when a spell you cast misses is now switched OFF!") 
	end
end

--
-- Chat/Audio Announce Spell Failures
--
function ChatAnnounceSpellFailure_OnClick()
	if ChatAnnounceSpellFailure:GetChecked() then AfterlifeSettings[11] = true else AfterlifeSettings[11] = false end
	if AfterlifeSettings[11] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce when a spell you cast fails is turned ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce when a spell you cast fails is turned OFF!") 
	end	
end

function AudioAnnounceSpellFailure_OnClick()
	if AudioAnnounceSpellFailure:GetChecked() then AfterlifeSettings[12] = true else AfterlifeSettings[12] = false end
	if AfterlifeSettings[12] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when a spell you cast fails is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when a spell you cast fails is now switched OFF!") 
	end
end

--
--	Chat/Audio Announce Interrupts
--
function ChatAnnounceInterrupts_OnClick()
	if ChatAnnounceInterrupts:GetChecked() then AfterlifeSettings[13] = true else AfterlifeSettings[13] = false end
	if AfterlifeSettings[13] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce when you interrupt a spell is turned ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce when you interrupt a spell is turned OFF!") 
	end	
end

function AudioAnnounceInterrupts_OnClick()
	if AudioAnnounceInterrupts:GetChecked() then AfterlifeSettings[14] = true else AfterlifeSettings[14] = false end
	if AfterlifeSettings[14] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when a I interrupt a spell is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when a I interrupt a spell is now switched OFF!") 
	end
end

--
--	Ignore if I break my own target
--
function IgnorePersonalBreaks_OnClick()
	if IgnorePersonalBreaks:GetChecked() then AfterlifeSettings[15] = true else AfterlifeSettings[15] = false end
	if AfterlifeSettings[15] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 You are now ignoring your own breaks (no announces to chat or audio).") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 You will announce your own breaks and play audio based on your settings.") 
	end	
end

--
--	Announce in Battlegrounds
--
function AnnounceInBG_OnClick()
	if AnnounceInBG:GetChecked() then AfterlifeSettings[42] = true else AfterlifeSettings[42] = false end
	if AfterlifeSettings[42] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 You will announce / play audio in battlegrounds based on your settings.") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 You will not announce any crowd controls in the battlegrounds.") 
	end	
end

--
--	Display Aieee popup
--
function DisplayBatmanPopup_OnClick()
	if DisplayBatmanPopup:GetChecked() then AfterlifeSettings[21] = true else AfterlifeSettings[21] = false end
	if AfterlifeSettings[21] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Display a batman style Aieee popup when your target breaks is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Display a batman style Aieee popup when your target breaks is now switched OFF!") 
	end	
end

--
--	3D Target Frame
--
function Display3DTargetFrame_OnClick()
	if Display3DTargetFrame:GetChecked() then AfterlifeSettings[16] = true else AfterlifeSettings[16] = false end
	if AfterlifeSettings[16] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Display a 3D controlled target frame is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Display a 3D controlled target frame is now switched OFF!") 
	end	
end

----------------------------------------- BAR ADJUSTMENT ----------------------------------------------


--
--	Bar Height
--
function BarSliderHeight_OnValueChanged()
	local value = math.floor(BarSliderHeight:GetValue())
	AfterlifeHeightText:SetText(value)	
	AfterlifeSettings[25] = value
	AfterlifeSettings[34] = value
	AfterlifePrimaryGroup:SetHeight(AfterlifeSettings[25])
	AfterlifeDiminishGroup:SetHeight(AfterlifeSettings[34])
end

--
-- Bar Width
--
function BarSliderWidth_OnValueChanged()
	local value = math.floor(BarSliderWidth:GetValue())
	AfterlifeWidthText:SetText(value)	
	AfterlifeSettings[26] = value
	AfterlifeSettings[35] = value
	AfterlifePrimaryGroup:SetWidth(AfterlifeSettings[26])
	AfterlifeDiminishGroup:SetWidth(AfterlifeSettings[35])
end

--
--	Bar Font
--
function BarSliderFont_OnValueChanged()
	local value = math.floor(BarSliderFont:GetValue())
	AfterlifeFontSizeText:SetText(value)	
	AfterlifeSettings[30] = value
	AfterlifeSettings[39] = value
	AfterlifePrimaryGroup:SetGroupFontSize(AfterlifeSettings[30])
	AfterlifeDiminishGroup:SetGroupFontSize(AfterlifeSettings[39])
end

--
--	Bar Texture
--
function BarSliderTexture_OnValueChanged()
	local value = math.floor(BarSliderTexture:GetValue())
	AfterlifeSettings[27] = value
	AfterlifeSettings[36] = value
	AfterlifeGroupTexture:SetTexture(AfterlifeTextures[value])
	AfterlifePrimaryGroup:SetTexture(AfterlifeTextures[AfterlifeSettings[27]])
	AfterlifeDiminishGroup:SetTexture(AfterlifeTextures[AfterlifeSettings[36]])
end


---------------------------------------------------- 3D Target Position ----------------------------------------------------

--
--	3D Target Position (From Left)
--
function Controlled3DTargetLeft_OnValueChanged()
	local value = math.floor(Controlled3DTargetLeft:GetValue())
	Afterlife3DLeftText:SetText(value)	
	AfterlifeSettings[19] = value
	update3DPosition()
end

--
--	3D Target Position (From Top)
--
function Controlled3DTargetTop_OnValueChanged()
	local value = math.floor(Controlled3DTargetTop:GetValue())
	Afterlife3DTopText:SetText(value)	
	AfterlifeSettings[20] = value
	update3DPosition()
end

--
--	3D Target Height
--
function Controlled3DTargetHeight_OnValueChanged()
	local value = math.floor(Controlled3DTargetHeight:GetValue())
	Afterlife3DHeightText:SetText(value)	
	AfterlifeSettings[18] = value
	update3DSize()	
end

-- 
-- 3D Target Width
--
function Controlled3DTargetWidth_OnValueChanged()
	local value = math.floor(Controlled3DTargetWidth:GetValue())
	Afterlife3DHeightText:SetText(value)	
	AfterlifeSettings[17] = value
	update3DSize()		
end
